/*
 * acct
 *    Switch process accounting on or off
 *    It must be run as root!
 * 
 * (!c) 2002 by Ighighi
 * Venezuela
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

static void exit_usage(const char *progname);

static void exit_usage(const char *progname)
{
    fprintf(stderr, "Usage: %s on|off [filename]\n", progname);
    exit(1);
}

int main(int argc, char *argv[])
{
    char *filename = NULL;
    
    if (argc == 1) {
	exit_usage(argv[0]);
    }
    
    if (! strcmp(argv[1], "on")) {
	if (argc != 3) {
	    exit_usage(argv[0]);
	}
	filename = argv[2];
    }
    else if (! strcmp(argv[1], "off")) {
	filename = NULL;
    }
    else {
	exit_usage(argv[0]);
    }

    if (acct(filename) < 0) {
	perror("acct()");
	exit(1);
    }
    
    return 0;
}
