/*
 * confstr
 *    Uses confstr(3) to get configuration dependent string variables
 *
 * (!c) 2002 by Ighighi
 * Venezuela
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define __EXTENSIONS__	/* hack to get confstr() prototype on SunOS 5.x */
#include <unistd.h>
#include <errno.h>

static void print_confstr(const char *s, int name);

#define do_it(name)	print_confstr(#name, name)

static void print_confstr(const char *s, int name)
{
    char *buf;
    int n;
    
    n = confstr(name, NULL, 0);
    if (! n) {
	fprintf(stderr, "Error: ");
	perror(s);
    }
    else {
	buf = (char *) malloc(n * sizeof(char));
	if (! buf) {
	    printf("Error: malloc(): %s\n", strerror(errno));
	}
	else {
	    printf("%-35s    ", s);	    
	    confstr(name, buf, n);
	    printf("%s\n", buf);
	    free(buf);
	}
    }

    return;
}

int main(void)
{

    printf("%-35s    %s\n", "name", "value");
    
#ifdef _CS_PATH
    do_it(_CS_PATH);
#endif

#ifdef _CS_LFS_CFLAGS
    do_it(_CS_LFS_CFLAGS);
#endif

#ifdef _CS_LFS_LDFLAGS
    do_it(_CS_LFS_LDFLAGS);
#endif

#ifdef _CS_LFS_LIBS
    do_it(_CS_LFS_LIBS);
#endif

#ifdef _CS_LFS_LINTFLAGS
    do_it(_CS_LFS_LINTFLAGS);
#endif

#ifdef _CS_LFS64_CFLAGS
    do_it(_CS_LFS64_CFLAGS);
#endif

#ifdef _CS_LFS64_LDFLAGS
    do_it(_CS_LFS64_LDFLAGS);
#endif

#ifdef _CS_LFS64_LIBS
    do_it(_CS_LFS64_LIBS);
#endif

#ifdef _CS_LFS64_LINTFLAGS
    do_it(_CS_LFS64_LINTFLAGS);
#endif

#ifdef _CS_XBS5_ILP32_OFF32_CFLAGS
    do_it(_CS_XBS5_ILP32_OFF32_CFLAGS);
#endif

#ifdef _CS_XBS5_ILP32_OFF32_LDFLAGS
    do_it(_CS_XBS5_ILP32_OFF32_LDFLAGS);
#endif

#ifdef _CS_XBS5_ILP32_OFF32_LIBS
    do_it(_CS_XBS5_ILP32_OFF32_LIBS);
#endif

#ifdef _CS_XBS5_ILP32_OFF32_LINTFLAGS
    do_it(_CS_XBS5_ILP32_OFF32_LINTFLAGS);
#endif

#ifdef _CS_XBS5_ILP32_OFFBIG_CFLAGS
    do_it(_CS_XBS5_ILP32_OFFBIG_CFLAGS);
#endif

#ifdef _CS_XBS5_ILP32_OFFBIG_LDFLAGS
    do_it(_CS_XBS5_ILP32_OFFBIG_LDFLAGS);
#endif

#ifdef _CS_XBS5_ILP32_OFFBIG_LIBS
    do_it(_CS_XBS5_ILP32_OFFBIG_LIBS);
#endif

#ifdef _CS_XBS5_ILP32_OFFBIG_LINTFLAGS
    do_it(_CS_XBS5_ILP32_OFFBIG_LINTFLAGS);
#endif

#ifdef _CS_XBS5_LP64_OFF64_CFLAGS
    do_it(_CS_XBS5_LP64_OFF64_CFLAGS);
#endif

#ifdef _CS_XBS5_LP64_OFF64_LDFLAGS
    do_it(_CS_XBS5_LP64_OFF64_LDFLAGS);
#endif

#ifdef _CS_XBS5_LP64_OFF64_LIBS
    do_it(_CS_XBS5_LP64_OFF64_LIBS);
#endif

#ifdef _CS_XBS5_LP64_OFF64_LINTFLAGS
    do_it(_CS_XBS5_LP64_OFF64_LINTFLAGS);
#endif

#ifdef _CS_XBS5_LPBIG_OFFBIG_CFLAGS
    do_it(_CS_XBS5_LPBIG_OFFBIG_CFLAGS);
#endif

#ifdef _CS_XBS5_LPBIG_OFFBIG_LDFLAGS
    do_it(_CS_XBS5_LPBIG_OFFBIG_LDFLAGS);
#endif

#ifdef _CS_XBS5_LPBIG_OFFBIG_LIBS
    do_it(_CS_XBS5_LPBIG_OFFBIG_LIBS);
#endif

#ifdef _CS_XBS5_LPBIG_OFFBIG_LINTFLAGS
    do_it(_CS_XBS5_LPBIG_OFFBIG_LINTFLAGS);
#endif

#ifdef _CS_POSIX_V6_ILP32_OFF32_CFLAGS
    do_it(_CS_POSIX_V6_ILP32_OFF32_CFLAGS);
#endif

#ifdef _CS_POSIX_V6_ILP32_OFF32_LDFLAGS
    do_it(_CS_POSIX_V6_ILP32_OFF32_LDFLAGS);
#endif

#ifdef _CS_POSIX_V6_ILP32_OFF32_LIBS
    do_it(_CS_POSIX_V6_ILP32_OFF32_LIBS);
#endif

#ifdef _CS_POSIX_V6_ILP32_OFF32_LINTFLAGS
    do_it(_CS_POSIX_V6_ILP32_OFF32_LINTFLAGS);
#endif

#ifdef _CS_POSIX_V6_ILP32_OFFBIG_CFLAGS
    do_it(_CS_POSIX_V6_ILP32_OFFBIG_CFLAGS);
#endif

#ifdef _CS_POSIX_V6_ILP32_OFFBIG_LDFLAGS
    do_it(_CS_POSIX_V6_ILP32_OFFBIG_LDFLAGS);
#endif

#ifdef _CS_POSIX_V6_ILP32_OFFBIG_LIBS
    do_it(_CS_POSIX_V6_ILP32_OFFBIG_LIBS);
#endif

#ifdef _CS_POSIX_V6_ILP32_OFFBIG_LINTFLAGS
    do_it(_CS_POSIX_V6_ILP32_OFFBIG_LINTFLAGS);
#endif

#ifdef _CS_POSIX_V6_LP64_OFF64_CFLAGS
    do_it(_CS_POSIX_V6_LP64_OFF64_CFLAGS);
#endif

#ifdef _CS_POSIX_V6_LP64_OFF64_LDFLAGS
    do_it(_CS_POSIX_V6_LP64_OFF64_LDFLAGS);
#endif

#ifdef _CS_POSIX_V6_LP64_OFF64_LIBS
    do_it(_CS_POSIX_V6_LP64_OFF64_LIBS);
#endif

#ifdef _CS_POSIX_V6_LP64_OFF64_LINTFLAGS
    do_it(_CS_POSIX_V6_LP64_OFF64_LINTFLAGS);
#endif

#ifdef _CS_POSIX_V6_LPBIG_OFFBIG_CFLAGS
    do_it(_CS_POSIX_V6_LPBIG_OFFBIG_CFLAGS);
#endif

#ifdef _CS_POSIX_V6_LPBIG_OFFBIG_LDFLAGS
    do_it(_CS_POSIX_V6_LPBIG_OFFBIG_LDFLAGS);
#endif

#ifdef _CS_POSIX_V6_LPBIG_OFFBIG_LIBS
    do_it(_CS_POSIX_V6_LPBIG_OFFBIG_LIBS);
#endif

#ifdef _CS_POSIX_V6_LPBIG_OFFBIG_LINTFLAGS
    do_it(_CS_POSIX_V6_LPBIG_OFFBIG_LINTFLAGS);
#endif

    return 0;
}
