/*
 * crypt
 *    encrypt a password
 * 
 * (!c) 2002 by Ighighi
 * Venezuela
 * 
 * Compile with -lcrypt
 * 
 * TODO:
 *   Check for a valid salt
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

char *getpass(const char *prompt);
char *crypt(const char *key, const char *salt);

int main(int argc, char *argv[])
{
    char *pass;
    char salt[2];
    char *hash;
    
    if (argc >= 3) {
	if (strlen(argv[2]) >= 1) {
	    memcpy(salt, argv[2], 2);
	}
	else {
	    fprintf(stderr, "Error: salt too short\n");
	    exit(1);
	}
	pass = argv[1];
    }
    else {
	pass = getpass("Password: ");
	printf("Salt: ");
	fgets(salt, 3, stdin);
    }
    
    hash = crypt(pass, salt);
    
    printf("%s\n", hash);
    
    /* Clean the memory used */
    memset(pass, 0, strlen(pass));
    memset(hash, 0, strlen(hash));
    
    return 0;
}
