/*
 * getpass()
 * 
 * (!c) 2001 by Ighighi
 * Venezuela
 */

#define _POSIX_SOURCE
#include <stdio.h>
#include <termios.h>
#include <unistd.h>

#define	TTY	"/dev/tty"

char *getpass(const char *prompt)
{

    struct termios term, termsav;
    static char pass[128];
    char *s;
    int c;
    FILE *tty = NULL;
    
    tty = fopen(TTY, "r+");
    if (! tty) return NULL;
	
    setbuf(tty, NULL);
    
    tcgetattr(fileno(tty), &term);
    termsav = term;

    term.c_lflag &= ~(ECHO|ISIG);
    tcsetattr(fileno(tty), TCSAFLUSH, &term);

    fputs(prompt, tty);

    s = pass;
    for (;;) {
	c = getc(tty);
	if(c == '\r' || c == '\n' || c == EOF)
	    break;
	if (s < &pass[127])
	    *s++ = c;
    }
    *s = '\0';

    fputs("\r\n", tty);

    tcsetattr(fileno(tty), TCSAFLUSH, &termsav);

    fclose(tty);

    return pass;
}
