/*
 * readlink:
 *   Print the contents of a symbolic link
 * 
 * (!c) 2001, 2002 by Ighighi
 * Venezuela
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <limits.h>	/* PATH_MAX */
#include <sys/param.h>	/* MAXPATHLEN (BSD) */

#ifndef PATH_MAX
#ifdef	MAXPATHLEN
#define PATH_MAX	MAXPATHLEN
#else
#define PATH_MAX	1024
#endif
#endif

int main(int argc, char *argv[])
{
    char path[PATH_MAX+1];    
    char *file;

    file = argv[1];
    if (! file) {
	fprintf(stderr, "Usage: %s file\n", argv[0]);
	exit(1);
    }

    memset(path, 0, sizeof(path));
    if (readlink(file, path, PATH_MAX) < 0) {
	fprintf(stderr, "readlink(): ");
	perror(file);
    }

    printf("%s\n", path);    
    
    exit(0);
}
	       
